#include <math.h>
#include <mpi.h>
#define TWOPI 2* 3.1415926535897932384626434

void Scramble(float *output_a, float *input_a, int N_d){
    int j,n1,n2,i,k;
    float temp;
    j = 0;
    n1 = (N_d-1);
    n2 = N_d>>1;
    for (i = 0; i < n1 ; i++){
	if (i < j)
	{
	    temp = output_a[j];
	    output_a[j] = output_a[i];
	    output_a[i] = temp;
	    temp = input_a[j];
	    input_a[j] = input_a[i];
	    input_a[i] = temp;
	}
	
	k = n2;
	while (k <= j)
	{
	    j = j-k;
	    k = k>>1;
		}
	j = (j+k);
    }
}
/*
   arguments:
   float* w1_a : real data array
   float* w2_a : imagi. data array
   
   return: void
   implements a real discrete fourier transform
   */

void lookup_cc(float* w1_a, float* w2_a, int N_d, int Sign) {
{
    float phi = 0;
    float wn = (float)(Sign*(TWOPI/N_d));
    int i;
    
    for(i=1; i<N_d+1; i++)
	
    {
	phi = wn*(i-1);
	w1_a[i-1]=cos(phi);
	w2_a[i-1]=sin(phi);
    } 
}

}

/*  method: powof2_cc
    
    This code is based on the code by Sitton of the Rice University.
    
    arguments: none
    
    return: log base 2 of n = 2**m, m = powof2(n).
    
    routine used to find number of stages in a FFT computation
    */

int powof2_cc(int N_d){
     
     /*  define local variables
      */
     int i, m;
     i = 1;
     m = 0;
     
     while (i < N_d){
	 i = (int)(i+i);
	 m = (int)(m+1);
     }
     
     /* if not power of two return -1
      */
     if (i!= N_d){
	 return -1;
     }
     
     return m;
     
 }
     
     
