#include <math.h>
#define TWOPI 2* 3.1415926535897932384626434

void Scramble(float *output_a, float *temp_input, int N_d){
    int j,n1,n2,i,k;
    float temp;
   
    j = 0;
    for (i = 0; i < N_d - 1; i++){
    if (i < j){
      temp = output_a[j];
      output_a[j] = output_a[i];
      output_a[i] = temp;
      temp = temp_input[j];
      temp_input[j] = temp_input[i];
      temp_input[i] = temp;
  }
    k = N_d>>2;
    while (k*3 <= j){
      j = j - (k*3);
      k = k>>2;
}
    j = j+k;
}
}


/*  method: powof2_cc
    
    This code is based on the code by Sitton of the Rice University.
    
    arguments: none
    
    return: log base 2 of n = 2**m, m = powof2(n).
    
    routine used to find number of stages in a FFT computation
    */

int powof2_cc(int N_d){


     
     /*  define local variables
      */
     int i, m;
     i = 1;
     m = 0;
  
     while (i < N_d){
	 i = (int)(i+i);
	 m = (int)(m+1);
     }
     
     /* if not power of two return -1
      */
     if (i!= N_d){
	 return -1;
     }
     
     return m;
     
 }
     
     
