#include <math.h>
#define TWOPI 2* 3.1415926535897932384626434

void Scramble(float *output_a, int N_d) {
    int j,n1,n2,i,k;
    float temp;
   
    j = 0;
    for (i = 0; i < N_d - 1; i++){
	if (i < j){
	    temp = output_a[j];
	    output_a[j] = output_a[i];
	    output_a[i] = temp;
	}
    }
}

void srfft_new_lookup_cc(float* cos_a, float* sin_a, int N_d){

	float  t, t0, t1, t2, t3;
	int     i, n2, n4;

	t = TWOPI/N_d;
	n2 = N_d >> 1;
	n4 = n2 >> 1;
	sin_a[N_d-n4] = cos_a[n2] = -(sin_a[n4] = cos_a[0] = t0 = 1.0);
	cos_a[N_d-n4] = cos_a[n4] = sin_a[n2] = sin_a[0] = t1 = 0.0;

	t2 = cos(t);
	t3 = sin(t);

/*  Fill the cos-sin tables     */

	for (i = 1; i < n4; i++)
	{
		cos_a[n2+i] = cos_a[n2-i] = -(cos_a[N_d-i] = cos_a[i] = t = t0*t2 - t1*t3);
		sin_a[n2+i] = sin_a[N_d-i] = -(sin_a[n2-i] = sin_a[i] = t1 = t0*t3 + t1*t2);
		t0 = t;
	}
	
}

/*  method: powof2_cc
    
    This code is based on the code by Sitton of the Rice University.
    
    arguments: none
    
    return: log base 2 of n = 2**m, m = powof2(n).
    
    routine used to find number of stages in a FFT computation
    */

int powof2_cc(int N_d){


     
    /*  define local variables
     */
    int i, m;
    i = 1;
    m = 0;
     while (i < N_d){
	i = (int)(i+i);
	m = (int)(m+1);
    }
     
    /* if not power of two return -1
     */
    if (i!= N_d){
	return -1;
    }
     
    return m;
     
}

     
